/*--------------------------------------------------------------------------------------
// Vorarbeit für Snake Software mit INTRO-HSHL-LOGO                                   //
// Autor: Erwin Büttner                                                               //
// Basiert: Basiert auf das Programm von Stefan Vogel & Christo Tsibadze (Projekt47b) //                                
// Datum: 21.01.2018                                                                 //
//----------------------------------------------------------------------------------  */


#include "FastLED.h"
#include "Snake.h"
#define NUM_LEDS 144
#define LEDS_PER_ROW 12
#define DATA_PIN 9



const byte numChars = 21;
char receivedChars[numChars];
boolean newData = false;

const unsigned char X = 12;
const unsigned char Y = 12;



unsigned char Level_Old = 10;

Snake snakeGame(X,Y,15);            
CRGB leds[NUM_LEDS];




//==================================================================================================================================
//==================================================================================================================================

void setup() {
   
  Serial.begin(9600);  
  snakeGame.setBodyColor(128, 255, 0);//optionally set the color of the snakeparts
  snakeGame.setFoodColor(0,160,255);//optionally set the color of the food
  snakeGame.setHeadColor(125,0,160);//optionally set the color of the snakeparts
  FastLED.addLeds<WS2812B, DATA_PIN, GRB>(leds, NUM_LEDS).setCorrection(TypicalLEDStrip);
  delay(500);
  
}
 
//==================================================================================================================================
//==================================================================================================================================

void recvWithStartEndMarkers() 
{
     static boolean recvInProgress = false;
     static byte ndx = 0;
     char startMarker = '[';
     char endMarker = ']';
 
     char rc;
 
     if (Serial.available() > 0) 
     {
          rc = Serial.read();
          if (recvInProgress == true) 
          {
               if (rc != endMarker) 
               {
                    receivedChars[ndx] = rc;
                    ndx++;
                    if (ndx >= numChars) { ndx = numChars - 1; }
               }
               else 
               {
                     receivedChars[ndx] = '\0'; // terminate the string
                     recvInProgress = false;
                     ndx = 0;
                     newData = true;
               }
          }
          else if (rc == startMarker) { recvInProgress = true; }
     }
}

//==================================================================================================================================
//==================================================================================================================================

void INTRO()
{
     for(unsigned char whiteLed = 0; whiteLed < NUM_LEDS; whiteLed++) {
      // Turn our current led on to white, then show the leds
      if(whiteLed%8==0)
      {leds[whiteLed] = CRGB::White;};
      if(whiteLed%8==1)
      {leds[whiteLed] = CRGB::Blue;};      
      if(whiteLed%8==2)
      {leds[whiteLed] = CRGB::Red;};
      if(whiteLed%8==3)
      {leds[whiteLed] = CRGB::Green;};
      if(whiteLed%8==4)
      {leds[whiteLed] = CRGB::Purple;};
      if(whiteLed%8==5)
      {leds[whiteLed] = CRGB::Orange;};
      if(whiteLed%8==6)
      {leds[whiteLed] = CRGB::Brown;};
      if(whiteLed%8==7)
      {leds[whiteLed] = CRGB::Pink;};
            
      // Show the leds (only one of which is set to white, from above)
      FastLED.show();

      // Wait a little bit
      delay(1);
      
      // Turn our current led back to black for the next loop around
      leds[whiteLed] = CRGB::Black;
   };
   
      for(unsigned char Logo_dimmer = 0; Logo_dimmer<255; Logo_dimmer++)
      {
        for(unsigned char HSHL_Schwarz = 0; HSHL_Schwarz<144; HSHL_Schwarz++)
              {
                leds[HSHL_Schwarz].setRGB( 150, 100, 150);
                
              }
              

        FastLED.show();
        delay(1);
        delay(10000);
      }
  
}
//==================================================================================================================================
//==================================================================================================================================

int setPixel(int x, int y, byte r, byte g, byte b)
{
  int ledID = NUM_LEDS - (y * LEDS_PER_ROW) - x - 1 ;
  leds[ledID].setRGB(r,g,b);
  return ledID;
}

//==================================================================================================================================
//==================================================================================================================================

void changeRGBtoGBR()
{
    for(unsigned char whiteLed = 0; whiteLed < NUM_LEDS; whiteLed++)
    {
      leds[whiteLed].setRGB(leds[whiteLed].g , leds[whiteLed].b, leds[whiteLed].r);
    }
}

//==================================================================================================================================
//==================================================================================================================================

void clearScreen()
{
  for(unsigned char i=0; i<Y;i++) //Grüne Spielwiese
  {
        for(unsigned char whiteLed = 7+i*LEDS_PER_ROW; whiteLed < LEDS_PER_ROW*(i+1); whiteLed++)
        {
          leds[whiteLed].setRGB( 0, 255, 0);
        };
  };
    unsigned char Level=(snakeGame.getSnakeLenght()-1)/11;
    if(Level_Old!=Level)
    {
      for(unsigned char LevelStatus = 1+Level*LEDS_PER_ROW; LevelStatus<6+LEDS_PER_ROW*Level; LevelStatus++)
      {
        
        switch (Level)
        {
          case 0:{          leds[LevelStatus+12*LEDS_PER_ROW].setRGB( 60, 0, 255);           break;        };
          case 1:{          leds[LevelStatus+10*LEDS_PER_ROW].setRGB( 0, 0, 255);            break;        };
          case 2:{          leds[LevelStatus+ 8*LEDS_PER_ROW].setRGB( 0, 145, 255);          break;        };
          case 3:{          leds[LevelStatus+ 6*LEDS_PER_ROW].setRGB( 0, 255, 255);          break;        };
          case 4:{          leds[LevelStatus+ 4*LEDS_PER_ROW].setRGB( 0, 255, 130);          break;        };
          case 5:{          leds[LevelStatus+ 2*LEDS_PER_ROW].setRGB( 0, 255, 0);            break;        };
          case 6:{          leds[LevelStatus+ 0*LEDS_PER_ROW].setRGB( 128, 255, 0);          break;        };
          case 7:{          leds[LevelStatus- 2*LEDS_PER_ROW].setRGB( 162, 255, 0);          break;        };
          case 8:{          leds[LevelStatus- 4*LEDS_PER_ROW].setRGB( 196, 255, 0);          break;        };
          case 9:{          leds[LevelStatus- 6*LEDS_PER_ROW].setRGB( 255, 255, 0);          break;        };       
          case 10:{         leds[LevelStatus- 8*LEDS_PER_ROW].setRGB( 255, 210, 0);          break;        };    
          case 11:{         leds[LevelStatus-10*LEDS_PER_ROW].setRGB( 255, 120, 0);          break;        };
          case 12:{         leds[LevelStatus-12*LEDS_PER_ROW].setRGB( 255, 0, 0);            break;        };      
      };
  }


  if(Level_Old>=13)
  {
    Level_Old = 0;
  };
  Level_Old = Level;
    };
}

//==================================================================================================================================
//==================================================================================================================================

void loop() 
{ 
    INTRO();
    if (Serial.available() > 0)     {  recvWithStartEndMarkers(); }
      if (newData) { 
        newData = false;        
        if ( receivedChars[0] == 'S' )  
        {
           for(;;)
          {

            if (Serial.available() > 0)     {  recvWithStartEndMarkers(); }
            if (newData) { 
              newData = false;          
              if ( receivedChars[0] == 'N' )  
              {
                    if ( receivedChars[1] == 'U' )   // UP
                    { 
                        if ( receivedChars[2] == 'O'  && receivedChars[3] == 'N'  ) {snakeGame.goUp();}
                    }
        
                    if ( receivedChars[1] == 'D' )   // DOWN
                    {
                        if ( receivedChars[2] == 'O'  && receivedChars[3] == 'N'  ) {snakeGame.goDown();}
        
                    }
        
                    if ( receivedChars[1] == 'L' )   // LEFT
                    {
                        if ( receivedChars[2] == 'O'  && receivedChars[3] == 'N'  ) {snakeGame.goLeft();}           
        
                    }
        
                    if ( receivedChars[1] == 'R' )   // RIGHT
                    {
                        if ( receivedChars[2] == 'O'  && receivedChars[3] == 'N'  ) {snakeGame.goRight();}          
                    }
        
                    if ( receivedChars[1] == 'E' )   // Exit
                    {
                        break;
                    }
        
              }
            }
            Snake::pixel* snakeLimbs=snakeGame.getSnakeLimbs();//this needs to be updated every frame
            Snake::pixel* snakeFood = snakeGame.getFoodPositions();//this needs to be updated every frame
            clearScreen();
            setPixel(snakeFood[0].posX,(Y-1)-snakeFood[0].posY,snakeFood[0].pixelColor.r,snakeFood[0].pixelColor.g,snakeFood[0].pixelColor.b); // display the food
            for(unsigned char i=0; i<snakeGame.getSnakeLenght(); i++)
            {
              //display the snake, my setpixel method has x=0, y=0 at the top left, but the library has it at bottom left, so I invert the Y-Axis:
             setPixel(snakeLimbs[i].posX,(Y-1)-snakeLimbs[i].posY,snakeLimbs[i].pixelColor.r,snakeLimbs[i].pixelColor.g,snakeLimbs[i].pixelColor.b);
            }
            FastLED.show();
            snakeGame.tick();//main loop for the snake library
            if(snakeGame.wasGameReset())// if the snake bit itself or the wall, flash a little
            {
              for(unsigned char i=0; i<30; i++)
              {
                changeRGBtoGBR();
                FastLED.show();
                delay(5);
              }
                clearScreen();
                if (Serial.available() > 0)     {  recvWithStartEndMarkers(); }
                if (newData) { 
                newData = false;
                while ( receivedChars[1] == 'E' )   // Exit
                    {
                        break;
                    }
                }
            }
            else
            {
              delay(5);
            };
          };
        }
        
    delay(5);
    
}
}

  
 
 
 
 
 
